<script setup lang="ts">
import NavigationDrawer from '@/components/NavigationDrawer.vue'
import { ref } from 'vue'
import { useStockStore } from '@/stores/stock'
import type { Material } from '@/types/Material'
import { useRoute } from 'vue-router'
import type { VForm } from 'vuetify/components'

const route = useRoute()
const stockStore = useStockStore()
const search = ref('')
const dialogConfirm = ref(false)
const dialogReject = ref(false)

function save() {
  if (stockStore.editedMaterial.unit > -1) {
    dialogConfirm.value = true
  } else {
    dialogReject.value = true
  }
}

function closeDialogCon() {
  dialogConfirm.value = false
}

function close() {
  dialogReject.value = false
}

function Confirm(item: Material) {
  dialogConfirm.value = false
  Object.assign(stockStore.materials[item.id - 1], stockStore.editedMaterial)
  stockStore.closeDialog()
}
</script>
<template>
  <!-- <NavigationDrawer></NavigationDrawer> -->
  <v-toolbar flat color="#212121">
    <v-toolbar-title>CheckStock</v-toolbar-title>
    <v-spacer></v-spacer>

    <v-text-field
      v-model="search"
      prepend-inner-icon="mdi-magnify"
      density="compact"
      label="Search"
      single-line
      flat
      hide-details
      variant="solo-filled"
      style="width: 1px"
    ></v-text-field>

    <!-- Put Dialog -->
    <v-menu transition="slide-y-transition">
      <template v-slot:activator="{ props }">
        <v-btn v-bind="props" icon>
          <v-icon>mdi-dots-vertical</v-icon>
        </v-btn>
      </template>
      <v-list>
        <v-list-item>
          <v-list-item-title>
            <v-btn
              block
              active-color="deep-orange-darken-4"
              link
              title="Stock"
              :class="{ active: route.name === 'stock' }"
              :to="{ path: '/Stock' }"
              rounded="0"
              >Stock
            </v-btn>
          </v-list-item-title>
          <v-list-item-title>
            <v-btn
              active-color="deep-orange-darken-4"
              link
              title="OrderStock"
              :class="{ active: route.name === 'orderstock' }"
              :to="{ path: '/OrderStock' }"
              rounded="0"
              >OrderStock
            </v-btn>
          </v-list-item-title>
        </v-list-item>
      </v-list>
    </v-menu>
  </v-toolbar>
  <div>
    <v-data-table
      v-model:search="search"
      :headers="stockStore.headers"
      :items="stockStore.materials"
    >
      <template v-slot:top> </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-btn @click="stockStore.CheckStock(item)">Check</v-btn>
      </template>
    </v-data-table>
  </div>
  <!-- Dialog Check -->
  <v-dialog v-model="stockStore.CheckDialog" persistent width="500">
    <v-card>
      <v-card-title>
        <span class="text-h4">Material Name : {{ stockStore.editedMaterial.name }}</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refform" v-model="stockStore.form" @submit.prevent="stockStore.onSubmit()">
          <v-container>
            <v-row>
              <v-col cols="12" sm="12" md="12">
                <v-card-text class="text-h5"
                  >Minimum {{ stockStore.editedMaterial.min }}</v-card-text
                >
              </v-col>
              <v-col cols="12" sm="12" md="12">
                <v-text-field
                  v-model="stockStore.editedMaterial.unit"
                  :readonly="stockStore.loading"
                  class="mb-2"
                  clearable
                  label="Unit"
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small style="color: red">*Please fill data</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="primary" variant="text" size="larger" @click="stockStore.closeDialog()">
          Close
        </v-btn>
        <v-btn color="primary" variant="text" size="larger" @click="save()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
  <!-- Dialog Confirm -->
  <v-dialog v-model="dialogConfirm" max-width="500px">
    <v-card>
      <v-card-title class="text-h5" style="text-align: center">Confirm?</v-card-title>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="primary" variant="text" @click="closeDialogCon()">Cancel</v-btn>
        <v-btn color="primary" variant="text" @click="Confirm(stockStore.editedMaterial)">OK</v-btn>
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
  <!-- Dialog Reject-->
  <v-dialog v-model="dialogReject" max-width="500px">
    <v-card>
      <v-card-title class="text-h5" style="text-align: center">
        <v-icon icon="mdi-alert" density="compact" size="small"></v-icon>Material
        Invaid.</v-card-title
      >
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="primary" variant="text" @click="close()">OK</v-btn>
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
